#
# spec file for package ndoutils
#
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#

# norootforbuild

Name:           ndoutils
Summary:        Nagios v2.x/v3.x Data Output Utilities
Version:        1.4b8
Release:        1.37
Url:            http://www.nagios.org/
License:        GPL v2 or later
Group:          System/Monitoring
AutoReqProv:    on
Source0:        %{name}-%{version}.tar.bz2
Source1:        %{name}-init
Source2:        ndoutils-README.SuSE
Patch:          ndoutils-1.4b7-libpq-fe-include.patch
Requires:       nagios >= 2.0
PreReq:         mysql
%if 0%{?suse_version} > 1020
BuildRequires:  libmysqlclient-devel
%else
BuildRequires:  mysql-devel
%endif
# postgresql is currently not supported but will likely be added in the future
BuildRequires:  postgresql-devel
BuildRequires:  nagios-devel >= 2.0
BuildRequires:  tcpd
BuildRoot:      %_tmppath/%name-%version-build
%define		libexecdir %_prefix/lib/nagios/plugins
%define 	nsusr nagios
%define         nsgrp nagios

%description
NDOUtils is an Nagios addon allowing you to store Nagios data (current status 
information, state history, notification history, etc.) in a MySQL database.

This addon consists of an event broker module and a daemon.

Consider this addon to be experimental for the moment, although it will likely 
play a central role in the a new Nagios web interface in the future.


%prep
%setup -q 
%patch
%__install -m644 %{S:2} README.SuSE

%build
%configure \
    --enable-mysql \
    --with-mysql-lib=%_libdir/mysql \
    --with-mysql-inc=%_includedir/mysql \
    --enable-pgsql \
    --with-pgsql-lib=%_libdir \
    --with-pgsql-inc=%_includedir/pgsql \
    --with-ndo2db-user=%nsusr \
    --with-ndo2db-group=%nsgrp \
    --localstatedir=%{_localstatedir}/lib

%__make %{?jobs:-j%jobs}

%install
%__install -d %{buildroot}%{_sysconfdir}/init.d
%__install -d %{buildroot}%{_sysconfdir}/nagios
%__install -d %{buildroot}%{_sbindir}
%__install -d %{buildroot}%{_bindir}
%__install -d %{buildroot}%{_prefix}/lib/nagios/brokers
%__install -d %{buildroot}%{_localstatedir}/lib/ndo

%__install -d %_builddir/%name-%version/examples

%__install -m0755 src/ndo2db-3x     %{buildroot}%{_sbindir}/ndo2db
%__install -m0755 src/file2sock     %{buildroot}%{_bindir}/file2sock
%__install -m0755 src/log2ndo       %{buildroot}%{_bindir}/log2ndo
%__install -m0755 src/sockdebug     %{buildroot}%{_bindir}/sockdebug
%__install -m0755 src/ndomod-3x.o   %{buildroot}%{_prefix}/lib/nagios/brokers/ndomod.o
%__install -m0755 %{S:1}            %{buildroot}%{_sysconfdir}/init.d/ndo2db
cd %{buildroot}%{_sbindir}
ln -s ../..%{_sysconfdir}/init.d/ndo2db rcndo2db
cd %{_builddir}/%{name}-%{version}
#
# fix path names in config
#
# install -m0644 config/ndo2db.cfg %{buildroot}%_sysconfdir/nagios/ndo2db.cfg
%__sed -e "s@^socket_name=.*@socket_name=/var/spool/nagios/ndo.sock@g" \
    -e "s@^debug_file=.*@debug_file=/var/log/nagios/ndo2db.debug@g" config/ndo2db.cfg > %{buildroot}%{_sysconfdir}/nagios/ndo2db.cfg

# install -m0644 config/ndomod.cfg %{buildroot}%_sysconfdir/nagios/ndomod.cfg
%__sed -e "s@^output=.*@output=/var/spool/nagios/ndo.sock@g" \
    -e "s@^buffer_file=.*@buffer_file=/var/spool/nagios/ndomod.tmp@g" config/ndomod.cfg > %{buildroot}%{_sysconfdir}/nagios/ndomod.cfg
    
%__cat > %{_builddir}/%{name}-%{version}/config/nagios.cfg << EOF
# SAMPLE NAGIOS CONFIG SNIPPET FOR NDOMOD
#
# In order to have Nagios run the NDOMOD event broker module, you'll need
# to place a statement like the one found below in your main Nagios
# configuration file (nagios.cfg).

# Uncomment the line below if you're running Nagios 3.x
#broker_module=%{_prefix}/lib/nagios/brokers/ndomod.o config_file=%{_sysconfdir}/nagios/ndo2db.cfg
EOF

%__cat > %_builddir/%{name}-%{version}/config/misccommands.cfg << EOF
# SAMPLE NDO FILE ROTATION COMMAND
#
# This is an example Nagios command definition that can be used to
# rotate the NDO output file on a regular basis.  Adjust the paths, etc.
# to suit your needs.  This definition will need to be included in your
# Nagios config files if you want to use it.

define command{
        command_name    rotate_ndo_log
        command_line    /bin/mv /var/spool/nagios/ndo.dat /var/spool/nagios/ndo.\`date +%s\`
        }
EOF
chmod -x db/prepsql
chmod -x db/upgradedb
chmod -x db/installdb
strip %{buildroot}%{_bindir}/file2sock
strip %{buildroot}%{_bindir}/log2ndo
strip %{buildroot}%{_bindir}/sockdebug
strip %{buildroot}%{_sbindir}/ndo2db

%clean
%__rm -rf %{buildroot}

%postun
%insserv_cleanup ndo2db

%preun
%stop_on_removal ndo2db

%files 
%defattr(-,root,root)
%doc db docs/* Changelog README* REQUIREMENTS TODO UPGRADING
%doc config/misccommands.cfg config/nagios.cfg
%config(noreplace) %{_sysconfdir}/nagios/ndomod.cfg
%config(noreplace) %{_sysconfdir}/nagios/ndo2db.cfg
%attr(0755,%{nsusr},%{nsgrp}) %dir %{_localstatedir}/lib/ndo
%{_sysconfdir}/init.d/ndo2db
%{_bindir}/file2sock
%{_bindir}/log2ndo
%{_bindir}/sockdebug
%{_sbindir}/ndo2db
%{_sbindir}/rcndo2db
%dir %{_prefix}/lib/nagios
%dir %{_prefix}/lib/nagios/brokers
%{_prefix}/lib/nagios/brokers/ndomod.o

%changelog
* Sat Jan 12 2008 lars@linux-schulserver.de
- added some tips from Tom Throckmorton in README.SuSE
* Tue Nov 27 2007 lars@linux-schulserver.de
- use new libexecdir
* Mon Nov 19 2007 lars@linux-schulserver.de
- initial version 1.4b7
